object ComputeRandomProjectionParams {

	private type ℝ = Double

	def main(args : Array[String]) : Unit = args.map(_.toDouble) match {
		case Array(θ1, θ2, rec1, rec2) ⇒
			val toDims = bisect(toDimsEqn(θ1, θ2, rec1, rec2), 0, 1000)
			val (idxCt1, idxCt2) = (idxCtEqn(θ1, rec1, toDims), idxCtEqn(θ2, rec2, toDims))
			println(s"to dimensions = $toDims; index counts are $idxCt1 and $idxCt2 (they should be equal)")
	}

	def bisect(f : ℝ ⇒ ℝ, min : ℝ, max : ℝ) : ℝ = {
		val mid = min + (max - min) / 2 // more stable than (min + max) / 2
		if (mid == min || mid == max) mid
		else if (f(mid) < 0) bisect(f, mid, max)
		else bisect(f, min, mid)
	}

	def toDimsEqn(θ1 : ℝ, θ2 : ℝ, rec1 : ℝ, rec2 : ℝ)(toDims : ℝ) =
		logInvProb(θ1, toDims) / logInvProb(θ2, toDims) - log1p(-rec1) / log1p(-rec2)

	def idxCtEqn(θ : ℝ, rec : ℝ, toDims : ℝ) = log1p(-rec) / logInvProb(θ, toDims)

	def logInvProb(θ : ℝ, toDims : ℝ) = log1p(-pow(1 - θ / PI, toDims))
}
